


clear; 
load 'model';

% TESTING IMAGE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
totalScale = 7;  % total number of scales
Sx1 = zeros(1, totalScale); Sy1 = zeros(1, totalScale); 
ax = sx; ay = sy; % half size of bounding box
for(i=1:totalScale)
    J{i} = imresize(double(rgb2gray(imread('e2.jpg'))), (.7+(i-1)*.1)*fold, 'nearest');  % scaled images
   % J{i} = imresize(double(rgb2gray(imread('e1.jpg'))), (.7+(i-1)*.1)*fold, 'nearest');  % scaled images
    [sx1, sy1] = size(J{i}); 
    Sx1(i) = sx1; Sy1(i) = sy1; % sizes of images
    tss1{i} = zeros(sx1+ax, sy1+ay);  % log-likelihood score map for testing images
    sym1{i} = zeros(sx1, sy1);  % symbolic sketch on testing image
end
mscale = zeros(1, totalScale);  % log-likelihood score over scales


% VARIABLES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(['start filtering']);
tic
allfiltered1 = applyfilterfftms(J, allfilter, Sx1(totalScale), Sy1(totalScale));  % filter training images
allmaxed = initialmax(J, allfilter);  % to be changed to local maximum
disp(['filtering time: ' num2str(toc) ' seconds']);

% MEX C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mex Cfind.c;   % compile C code
disp(['start finding']);
tic
Cfind(totalScale, norient, allfiltered1, allmaxed, h, ax, ay, Mi, Mx, My, Mm, allsymbol(1, :), Lrange, Orange, sub, Totalsketch, Upperbound, tss1, sym1, Sx1, Sy1, mscale);
disp(['mex-C finding time: ' num2str(toc) ' seconds']);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    

[maxscale imax]= max(mscale);   % most likely scale
sx = Sx1(imax); sy = Sy1(imax); 
K = 1; bx =10; by = 10; cc = 3;  
col = 1; row = 1;
Iout = zeros(row*sx+(row-1)*(2*bx+cc), 2*col*sy+(col-1)*(2*by+cc))+255; 
i = 0;  
for (r = 1 : row)
    for (c = 1 : col)
        i = i+1; 
        if ((i>=1)&&(i<=K))
            towrite = J{imax}; 
            towrite = (255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
            Iout((r-1)*sx+1+(r-1)*(2*bx+cc): r*sx+(r-1)*(2*bx+cc), (c-1)*2*sy+1+(c-1)*(2*by+cc): (c-1)*2*sy+sy+(c-1)*(2*by+cc)) = towrite; 
            towrite =  -sym1{imax}; 
            towrite = (255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
            Iout((r-1)*sx+1+(r-1)*(2*bx+cc) : r*sx+(r-1)*(2*bx+cc), (c-1)*2*sy+sy+(c-1)*(2*by+cc)+1 : (c-1)*2*sy+sy+(c-1)*(2*by+cc)+sy) =towrite;  
        end
    end
end
for (r = 1 : row-1)
  Iout(r*sx+(r-1)*(2*bx+cc)+bx+1:r*sx+(r-1)*(2*bx+cc)+bx+cc, :) = 0; 
end
for (c = 1 : col-1)
  Iout(:, c*(sy*2)+(c-1)*(2*by+cc)+by+1:c*(sy*2)+(c-1)*(2*by+cc)+by+cc) = 0; 
end
outepsgif(Iout, 'ex5b_3_find'); 
%outepsgif(Iout, 'ex5b_4_find'); 


